Package org.springframework.batch.core

# Interface SkipListener<T,S>

All Superinterfaces:
  `StepListener`

All Known Implementing Classes:
  `CompositeSkipListener`, `MulticasterBatchListener`, `SkipListenerSupport`, `StepListenerSupport`

public interface SkipListener<T,S> extends StepListener
Interface for listener to skipped items. Callbacks will be called by `Step` implementations at the appropriate time in the step lifecycle. Implementers of this interface should not assume that any method will be called immediately after an error has been encountered. Because there may be errors later on in processing the chunk, this listener will not be called until just before committing.

Author:
  Dave Syer, Robert Kasanicky, Mahmoud Ben Hassine

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default void`
  `onSkipInProcess(T item, Throwable t)`
  This item failed on processing with the given exception, and a skip was called for.
  `default void`
  `onSkipInRead(Throwable t)`
  Callback for a failure on read that is legal, so is not going to be re-thrown.
  `default void`
  `onSkipInWrite(S item, Throwable t)`
  This item failed on write with the given exception, and a skip was called for.

- ## Method Details

  - ### onSkipInRead

    default void onSkipInRead(Throwable t)
    Callback for a failure on read that is legal, so is not going to be re-thrown. In case transaction is rolled back and items are re-read, this callback will occur repeatedly for the same cause. This will only happen if read items are not buffered.
    Parameters:
      `t` - cause of the failure

  - ### onSkipInWrite

    default void onSkipInWrite(S item, Throwable t)
    This item failed on write with the given exception, and a skip was called for.
    Parameters:
      `item` - the failed item
      `t` - the cause of the failure

  - ### onSkipInProcess

    default void onSkipInProcess(T item, Throwable t)
    This item failed on processing with the given exception, and a skip was called for.
    Parameters:
      `item` - the failed item
      `t` - the cause of the failure